<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- This file has been generated by tj3man v3.1.0 -->
<html lang="en" xml:lang="en" xmlns="http://www.w3.org/1999/xhtml">
 <head>
  <title>How_To_Contribute</title>
  <meta content="text/html; charset=utf-8" http-equiv="Content-Type"/>
 </head>
 <link href="css/tjmanual.css" rel="stylesheet" type="text/css"></link>
 <body>
  <div align="center">
   <h3 align="center">The TaskJuggler User Manual</h3>
   <em align="center">Project Management beyond Gantt Chart Drawing</em>
  </div>
  <br/>
  <hr/>
  <table style="width:90%; margin-left:5%; margin-right:5%"><tr>
    <td style="text-align:left; width:35%;">&lt;&lt; <a href="Installation.html">Installation</a> &lt;&lt;</td>
    <td style="text-align:center; width:30%;"><a href="toc.html">Table Of Contents</a></td>
    <td style="text-align:right; width:35%;">&gt;&gt; <a href="Getting_Started.html">Getting_Started</a> &gt;&gt;</td>
   </tr></table>
  <hr/>
  <br/>
  <div style="width:90%; margin-left:5%; margin-right:5%"><div class="manual">
    <h2 class="manual" id="How_to_Contribute">2.8 How to Contribute</h2>
    <h3 class="manual" id="Why_contribute">2.8.1 Why contribute?</h3>
    <p class="manual">TaskJuggler is an Open Source Project. It was developed by volunteers mostly in their spare time. Made available under the GNU General Public license and similar licenses, TaskJuggler can be shared and used free of charge by anybody who respects the license conditions. Does that mean you can use it without worrying about anything? Clearly not! Though users have no legal obligation to contribute, you should feel a moral obligation to support Open Source in whatever way you can. This can range from helping out other users with their first Linux installation to actively contributing to the TaskJuggler Project, not just as a programmer. The following section describes, how you can contribute to any of the components that are part of the TaskJuggler software releases.</p>
    <h3 class="manual" id="Preparing_a_contribution">2.8.2 Preparing a contribution</h3>
    <p class="manual">All TaskJuggler development is coordinated using the <a href="https://github.com/taskjuggler/TaskJuggler/issues" target="_top">github source code management platform</a>. All changes must be submitted using Git github so that we can track the authorship of each submission. There is <a href="http://help.github.com/" target="_top">excellent documentation</a> available on how to use github.</p>
    <p class="manual">Make sure you have followed the steps described in the <a href="Installation.html#Installation_Steps_for_Developers" target="_top">Installation Steps for Developers</a> chapter.</p>
    <p class="manual">If you have never used Git before, you need to configure it first. You need to set your name and email address. This information will be present in all patches that you submit.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">git config --global user.name "Your Name"
git config --global user.email "firstname.lastname@domain.org"
</pre></div>
    <p class="manual">Do not use the development snapshots or send your patches as plain diff files. We'd like to ensure that we know who contributed to TaskJuggler. Therefor we are only accepting signed-off git patches with full user names and valid email addresses.</p>
    <p class="manual">Next you need to find the files where you want to make your modifications. Sometimes files will be generated from other files. Do not change those generated files. Your changes will be overwritten the next time you call the make utility.</p>
    <h3 class="manual" id="Creating_a_Patch">2.8.3 Creating a Patch</h3>
    <p class="manual">When you are done with your changes, it's a good idea to test them. In the taskjuggler directory run the following commands.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">cd taskjuggler3
rake test
rake spec
rake manual
rake gem
</pre></div>
    <p class="manual">If there are no errors, you can check or test the result. If everything works fine, you can lock at your changes again.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">git diff
</pre></div>
    <p class="manual">The git-diff utility performs a line-by-line comparison of the files against the latest version in you local repository. Try to only make changes that have an impact on the generated files. Do not change indentation or line wrapping of paragraphs unless absolutely necessary. These kinds of changes increase the size of diff files and make it much harder to evaluate the patches. When making changes to the program code, please use exactly the same coding style as the rest of the code. If your contribution is large enough to justify a copyright claim, please indicate what copyright you claim in the patch. For modifications to existing files, we will assume that your contribution falls under the same license as the modified file. All new files will need to contain a license declaration, preferably GPL version 2. In any case, the license must be <a href="http://www.opensource.org/licenses" target="_top">an OSI accepted license</a> and be compatible with the GPL version 2 used by the rest of the project.</p>
    <p class="manual">Review all changes carefully. In case you have created new source files, you need to register them with your repository.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">git add FILENAME
</pre></div>
    <p class="manual">If you think you are done, you can commit your changes to your local repository.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">git commit -a -s
</pre></div>
    <p class="manual">The -s parameter is very important. We will only accept signed-off patches. By signing off on your patches you confirm that you wrote the code and have the right to pass it on as a patch. See <a href="http://gerrit.googlecode.com/svn/documentation/2.0/user-signedoffby.html" target="_top">this document</a> for more information!</p>
    <p class="manual">Please include a meaningful commit message. The first line (header line) should be prefixed by <code class="manual">Fix:</code> for bug fixes or <code class="manual">New:</code> for new features. This is used to automatically generate the change log from one release to another. So a bug that has been introduced after the last release and is fixed before the next release does not need to be included in the changelog. For those cases, don't use any prefix.</p>
    <p class="manual">After the header line leave a blank line and include one or more paragraphs with more detailed information about the patch. This information will also be included in the the change log if the header line has a prefix.</p>
    <p class="manual">If you fix a bug that was reported by somebody else, please also include a reported-by line:</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">Reported-by: whoever-reported-the-bug
</pre></div>
    <p class="manual">Then push it into your forked github repository.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">git push
</pre></div>
    <p class="manual">The final step is to send us a <a href="http://help.github.com/pull-requests/" target="_top">pull request</a> for your changes.</p>
    <h3 class="manual" id="Contributing_to_the_User_Manual">2.8.4 Contributing to the User Manual</h3>
    <p class="manual">The user manual is currently a rough port of the 2.x manual. It contains many inaccuracies and does not provide much more than a tutorial and a syntax reference. Any help to turn this into a real user manual is greatly appreciated.</p>
    <p class="manual">The manual is composed from 3 different sources.</p>
    <ol>
     <li>The sources for normal pages are in MediaWiki format and can be found in the <code class="manual">manual</code> directory of the source distribution.</li>
     <li>The information in the syntax reference is extracted from the TJP parser source code. It can be found in the file <code class="manual">lib/TjpSyntaxRules.rb</code>. You can ignore all but the <code class="manual">doc(...)</code>, <code class="manual">arg(...)</code> and <code class="manual">example(...)</code> sections.</li>
     <li>The TJP examples are in the <code class="manual">test/TestSuite/Syntax/Correct</code> directory.</li>
    </ol>
    <p class="manual">The following commands build the HTML files for the manual in the <code class="manual">data/manual</code> directory.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">cd lib
ruby UserManual.rb 
</pre></div>
    <h3 class="manual" id="Contributing_to_the_Test_Suite">2.8.5 Contributing to the Test Suite</h3>
    <p class="manual">The test suite can be found in the <code class="manual">test</code> and <code class="manual">spec</code> directories. It contains unit and system tests but is very rudimentary at the moment. Adding more system tests to the test/CSV-Report directory is probably the best place to start. Originally, TaskJuggler used classic Ruby unit tests, but a migration to <a href="http://rspec.info/|RSpec-2" target="_top">http://rspec.info/|RSpec-2</a> is in the works now. New tests should be written as RSpec tests unless they require infrastructure only available in the <code class="manual">test</code> directory.</p>
    <h3 class="manual" id="Contributing_to_the_Ruby_code">2.8.6 Contributing to the Ruby code</h3>
    <p class="manual">For the first stable TaskJuggler release we have most 2.x features supported. The few things that break backwards compatibility are documented in the <a href="TaskJuggler_2x_Migration.html">TaskJuggler_2x_Migration</a> section.</p>
    <p class="manual">In general, patches are very welcome. Please follow the coding style and naming conventions used in the existing code. Larger changes should be preceded by a discussion in the <a href="http://www.taskjuggler.org/contact.html" target="_top">TaskJuggler Developer Forum</a>.</p>
    <h3 class="manual" id="Some_final_words_to_Contributors">2.8.7 Some final words to Contributors</h3>
    <p class="manual">We do welcome all contributions, but please understand that we reserve the right to reject any contribution that does not follow the above guidelines or otherwise conflicts with the goals of the TaskJuggler team. It is a good idea to contact the team prior to making any larger efforts.</p>
   </div></div>
  <br/>
  <hr/>
  <table style="width:90%; margin-left:5%; margin-right:5%"><tr>
    <td style="text-align:left; width:35%;">&lt;&lt; <a href="Installation.html">Installation</a> &lt;&lt;</td>
    <td style="text-align:center; width:30%;"><a href="toc.html">Table Of Contents</a></td>
    <td style="text-align:right; width:35%;">&gt;&gt; <a href="Getting_Started.html">Getting_Started</a> &gt;&gt;</td>
   </tr></table>
  <hr/>
  <br/>
  <div align="center" style="font-size:10px;">Copyright (c) 2006, 2007, 2008, 2009, 2010, 2011, 2012 by Chris Schlaeger &lt;chris@linux.com&gt;.<a href="http://www.taskjuggler.org">TaskJuggler</a> is a trademark of Chris Schlaeger.</div>
 </body>
</html>
